//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%381DADC38060.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%381DADC38060.cm

//## begin module%381DADC38060.cp preserve=no
//## end module%381DADC38060.cp

//## Module: XSutility%381DADC38060; Package specification
//## Subsystem: XSUtil::Utils%3777E01D9D80
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Utils/XSutility.h

#ifndef XSUTILITY_H
#define XSUTILITY_H 1

//## begin module%381DADC38060.additionalIncludes preserve=no
#include "xsTypes.h"
#include <locale>
#include <sstream>
//## end module%381DADC38060.additionalIncludes

//## begin module%381DADC38060.includes preserve=yes
//## end module%381DADC38060.includes

// xsTypes
#include <main/xsTypes.h>
// functional
#include <functional>
//## begin module%381DADC38060.declarations preserve=no
//## end module%381DADC38060.declarations

//## begin module%381DADC38060.additionalDeclarations preserve=yes

#       include <cstdlib>
#       include <iosfwd>
#       include <iomanip>
#       include <valarray>
#       include <utility>
//#       include "Command/Command.h"
        class InvalidRange;
        class InputError;
        struct Tcl_Obj;
        class XSstream;
//## end module%381DADC38060.additionalDeclarations


//## Modelname: XSUtil::Utils::XSutility%39E3342C0341
namespace XSutility {
    //## begin XSutility%39E3342C0341.initialDeclarations preserve=yes
         
         void starPrint (const std::string& slogan, int j, std::ostream& s);
        
         int yesToQuestion (const string& prompt, int defaultAns, std::istream& a);

         // for a command with options listed in a map, prompt the user with
         // a list of valid responses.
         void printValidOptions(std::ostream& s, const string& command, const std::map<string,size_t>& options);
         
         string lowerCase(const string& inputString);
         
         string upperCase(const string& inputString);
         
         void find (const RealArray& array, const Real& target, int& n );
         
         void bisect( int& lower, int& upper, const RealArray& array, const Real& target, bool increasing); 
         
         bool isReal (const string& inputString, Real& realResult);
         
         // equality of RealArrays. Could be generalized to a template, but currently
         // only need to check RealArray objects
         bool equalVector(const RealArray& left, const RealArray& right, Real tolerance = 0);

         size_t isInteger(const string& inputString);
         
         // Inserts the escape char prior to every appearance of any of
         // the characters in specialChars string.
         // Useful for writing file names w/extended syntax to save files.
         string insertEscapeChars(const string& inputString,
                        const string& specialChars = string("[] \t"),
                        const char ESC = '\\');
         
         unsigned int openBrackets (const string& ss);

         unsigned int closeBrackets (const string& ss);
         
         void printStrings(const std::vector<string>& strings, std::ostream& s, int perLine, int fieldWidth=8);
         
         // Version string is actually stored in xs_version.  
         // XSVersionString is named that way for historical reasons.
         const string& xs_version();
         void XSVersionString(string &title, string &buildDate);
        
         std::pair<Real,Real> confidenceRange(Real confidenceLevel, std::vector<Real>& array);
         
         template <class T>
         void swap(T& left,T& right)
         {
                T temp(left);
                left = right;
                right = temp;                
         }
         
         // decodes registry keys of the form  outputName$outputIndex.
         void decodeKey(const string& input, string& outputName, size_t& outputIndex);
         
         RealArray gehrelsWeighting(const RealArray& rate, Real norm);
         
         RealArray churazovWeighting(const RealArray& rate, Real norm);
         
      // The MapType parameter is truly redundant information, since it 
      // should be available from StdMap::mapped_type.  However, when 
      // StdMap::mapped_type is passed along as the vector type param,
      // all sorts of unpredictable compilation problems may arise on
      // Solaris compilers, and they don't always show up in this file.
         
	 template<typename StlMap, typename MapType>
	 std::vector<MapType> values(typename StlMap::const_iterator beg, 
							  typename StlMap::const_iterator end)
	 {
	     size_t n = 0;
#ifndef STD_COUNT_DEFECT
	     n = std::distance(beg, end);
#else
	     std::distance(beg, end, n);
#endif
	     std::vector<MapType> vals(n);
	     
	     typename StlMap::const_iterator pos = beg;

	     for(size_t i = 0; i < n; ++i, ++pos)
		 vals[i] = pos->second;
	     
	     return vals;
	 }

	 string getRunPath();

	 string peek(std::istream& s, size_t bytes);
	 
    //## end XSutility%39E3342C0341.initialDeclarations

    //## Class: Match1stKeyString%38F1F7A29B90; Parameterized Class
    //## Category: XSUtil::Utils::XSutility%39E3342C0341
    //## Subsystem: XSUtil::Utils%3777E01D9D80
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    //## Uses: <unnamed>%38F241948970;std::binary_function { -> }

    template <class T>
    struct Match1stKeyString : public std::binary_function<T,std::string,bool>  //## Inherits: <unnamed>%38F2462A8830
    {

        //## Other Operations (specified)
          //## Operation: operator()%38F1F8A69280
          bool operator () (const T& t, const std::string& k) const;

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Class: MatchName%373B41F9D5F9; Parameterized Class
    //## Category: XSUtil::Utils::XSutility%39E3342C0341
    //## Subsystem: XSUtil::Utils%3777E01D9D80
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    template <class T>
    struct MatchName : public std::binary_function<T, std::string, bool>  //## Inherits: <unnamed>%38F32AFB98E8
    {

        //## Other Operations (specified)
          //## Operation: operator %FE9D6CE70007;  C++
          bool operator () (const T& left, const string& right) const;

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Class: MatchPtrName%373B41FBE20A; Parameterized Class
    //## Category: XSUtil::Utils::XSutility%39E3342C0341
    //## Subsystem: XSUtil::Utils%3777E01D9D80
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    template <class T>
    struct MatchPtrName : public std::binary_function<T*, std::string, bool>  //## Inherits: <unnamed>%38F32720F660
    {

        //## Other Operations (specified)
          //## Operation: operator %F9FBEDFB0032;  C++
          //	Parameterized Class MatchPtrName
          bool operator () (const T* left, const string& right) const;

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Class: Carray%3A01AFEB00B3; Parameterized Class
    //## Category: XSUtil::Utils::XSutility%39E3342C0341
    //## Subsystem: XSUtil::Utils%3777E01D9D80
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    template <typename T>
    struct Carray 
    {

        //## Other Operations (specified)
          //## Operation: operator()%3A01B001003C
          T* operator () (const std::valarray<T>& inArray);

          //## Operation: operator()%3A01B0410137
          T* operator () (const std::vector<T>& inArray);

          //## Operation: operator()%3A01B10701ED
          std::vector<T> operator () (T* inArray, size_t n);

      public:
      protected:
      private:
      private: //## implementation
    };

    //## begin XSutility::fileType%3A37DF8A032E.preface preserve=yes
    //## end XSutility::fileType%3A37DF8A032E.preface

    //## Class: fileType%3A37DF8A032E
    //## Category: XSUtil::Utils::XSutility%39E3342C0341
    //## Subsystem: XSUtil::Utils%3777E01D9D80
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    typedef enum {NONE,PHA,BCK,COR,RSP,ARF} fileType;

    //## begin XSutility::fileType%3A37DF8A032E.postscript preserve=yes
//  template <class T>
//  bool MatchName<T*>::operator() (const T*& left, const string& right) const;
    //## end XSutility::fileType%3A37DF8A032E.postscript

    //## Class: auto_array_ptr%3BB485510272; Parameterized Class
    //## Category: XSUtil::Utils::XSutility%39E3342C0341
    //## Subsystem: XSUtil::Utils%3777E01D9D80
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    template <typename X>
    class auto_array_ptr 
    {
      public:
        //## Constructors (specified)
          //## Operation: auto_array_ptr%3BB486280259
          //## Exceptions: ()
          explicit auto_array_ptr (X* p = 0) throw ();

          //## Operation: auto_array_ptr%3BB4864901EE
          //## Exceptions: ()
          explicit auto_array_ptr (auto_array_ptr<X>& right) throw ();

        //## Destructor (generated)
          ~auto_array_ptr();

        //## Dereference Operation (generated)
          X& operator*() const;


        //## Other Operations (specified)
          //## Operation: get%3BB485910270
          //## Exceptions: ()
          X* get () const throw ();

          //## Operation: reset%3BB485AB0043
          //## Exceptions: ()
          X* reset (X* p) throw ();

          //## Operation: remove%3BB485B50394
          //## Exceptions: ()
          static void remove (X*& x) throw ();

          //## Operation: release%3BB485DB039A
          //## Exceptions: ()
          X* release () throw ();

          //## Operation: operator=%3BB486A3008E
          //## Exceptions: ()
          void operator = (auto_array_ptr<X>& right) throw ();

          //## Operation: operator[]%3BB486CA0342
          //## Exceptions: ()
          X& operator [] (size_t index) throw ();

          //## Operation: operator[]%3BB486EF037B
          //## Exceptions: ()
          X operator [] (size_t index) const throw ();

      protected:
      private:
      private: //## implementation
        // Data Members for Class Attributes

          //## Attribute: p%3BB487FD01C7
          //## begin XSutility::auto_array_ptr::p%3BB487FD01C7.attr preserve=no  private: X* {U} p
          X* m_p;
          //## end XSutility::auto_array_ptr::p%3BB487FD01C7.attr

    };

    //## Class: MatchSubKey%3C22596002B7; Parameterized Class
    //## Category: XSUtil::Utils::XSutility%39E3342C0341
    //## Subsystem: XSUtil::Utils%3777E01D9D80
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    template <typename T>
    struct MatchSubKey : public std::binary_function<T,string,bool>  //## Inherits: <unnamed>%3C2259EE0036
    {

        //## Other Operations (specified)
          //## Operation: operator()%3C2259B801EF
          bool operator () (const T& t, const string& k) const;

      public:
      protected:
      private:
      private: //## implementation
    };

    //## Class: Nocase%4810E6360350
    //	Functor class which can be used as the Cmp template
    //	argument for a std::map container, when case-insensitive
    //	searches and ordering are required.  (This code comes
    //	from Stroustrup C++ 17.1.4.1.)
    //## Category: XSUtil::Utils::XSutility%39E3342C0341
    //## Subsystem: XSUtil::Utils%3777E01D9D80
    //## Persistence: Transient
    //## Cardinality/Multiplicity: n



    struct Nocase 
    {

        //## Other Operations (specified)
          //## Operation: operator()%4810E814037A
          bool operator () (const string& x, const string& y) const;

      public:
      protected:
      private:
      private: //## implementation
    };

    // Parameterized Class XSutility::Match1stKeyString 


    //## Other Operations (inline)
    template <class T>
    inline bool Match1stKeyString<T>::operator () (const T& t, const std::string& k) const
    {
      //## begin XSutility::Match1stKeyString::operator()%38F1F8A69280.body preserve=yes
          // match against the first string of a map key delimited by colons.
          // T& t is a pair and T& t.first is a string. error...
          int i = t.first.find_first_of(':');
          if (i < 0 ) return (t.first == k);
          else
          {
                return (t.first.substr(0,k.length()) == k);   
          }
      //## end XSutility::Match1stKeyString::operator()%38F1F8A69280.body
    }

    // Parameterized Class XSutility::MatchName 


    //## Other Operations (inline)
    template <class T>
    inline bool MatchName<T>::operator () (const T& left, const string& right) const
    {
      //## begin XSutility::MatchName::operator %FE9D6CE70007.body preserve=yes
  return left.name() == right;
      //## end XSutility::MatchName::operator %FE9D6CE70007.body
    }

    // Parameterized Class XSutility::MatchPtrName 


    //## Other Operations (inline)
    template <class T>
    inline bool MatchPtrName<T>::operator () (const T* left, const string& right) const
    {
      //## begin XSutility::MatchPtrName::operator %F9FBEDFB0032.body preserve=yes
  return left->name() == right;
      //## end XSutility::MatchPtrName::operator %F9FBEDFB0032.body
    }

    // Parameterized Class XSutility::Carray 


    //## Other Operations (inline)
    template <typename T>
    inline T* Carray<T>::operator () (const std::valarray<T>& inArray)
    {
      //## begin XSutility::Carray::operator()%3A01B001003C.body preserve=yes
        size_t n = inArray.size();
        T* c = new T[n];
        for (size_t j = 0; j < n; ++j) c[j] = inArray[j];
        return c;    
      //## end XSutility::Carray::operator()%3A01B001003C.body
    }

    template <typename T>
    inline T* Carray<T>::operator () (const std::vector<T>& inArray)
    {
      //## begin XSutility::Carray::operator()%3A01B0410137.body preserve=yes
        size_t n = inArray.size();
        T* c = new T[n];
        for (size_t j = 0; j < n; ++j) c[j] = inArray[j];
        return c;    
      //## end XSutility::Carray::operator()%3A01B0410137.body
    }

    template <typename T>
    inline std::vector<T> Carray<T>::operator () (T* inArray, size_t n)
    {
      //## begin XSutility::Carray::operator()%3A01B10701ED.body preserve=yes
    std::vector<T> value(n);
    for (size_t j = 0; j < n; ++j) value[j] = inArray[j];
    return value;
      //## end XSutility::Carray::operator()%3A01B10701ED.body
    }

    // Parameterized Class XSutility::auto_array_ptr 

    // Parameterized Class XSutility::MatchSubKey 

    // Class XSutility::Nocase 

    // Parameterized Class XSutility::auto_array_ptr 

    template <typename X>
    auto_array_ptr<X>::auto_array_ptr (X* p) throw ()
      //## begin XSutility::auto_array_ptr::auto_array_ptr%3BB486280259.hasinit preserve=no
          : m_p(p)
      //## end XSutility::auto_array_ptr::auto_array_ptr%3BB486280259.hasinit
      //## begin XSutility::auto_array_ptr::auto_array_ptr%3BB486280259.initialization preserve=yes
      //## end XSutility::auto_array_ptr::auto_array_ptr%3BB486280259.initialization
    {
      //## begin XSutility::auto_array_ptr::auto_array_ptr%3BB486280259.body preserve=yes
      //## end XSutility::auto_array_ptr::auto_array_ptr%3BB486280259.body
    }

    template <typename X>
    auto_array_ptr<X>::auto_array_ptr (auto_array_ptr<X>& right) throw ()
      //## begin XSutility::auto_array_ptr::auto_array_ptr%3BB4864901EE.hasinit preserve=yes
        : m_p(right.release())
      //## end XSutility::auto_array_ptr::auto_array_ptr%3BB4864901EE.hasinit
      //## begin XSutility::auto_array_ptr::auto_array_ptr%3BB4864901EE.initialization preserve=yes
      //## end XSutility::auto_array_ptr::auto_array_ptr%3BB4864901EE.initialization
    {
      //## begin XSutility::auto_array_ptr::auto_array_ptr%3BB4864901EE.body preserve=yes
      //## end XSutility::auto_array_ptr::auto_array_ptr%3BB4864901EE.body
    }


    template <typename X>
    auto_array_ptr<X>::~auto_array_ptr()
    {
      //## begin XSutility::auto_array_ptr::~auto_array_ptr%3BB485510272_dest.body preserve=yes
    delete [] m_p;
      //## end XSutility::auto_array_ptr::~auto_array_ptr%3BB485510272_dest.body
    }


    template <typename X>
    X& auto_array_ptr<X>::operator*() const
    {
      //## begin XSutility::auto_array_ptr::operator*%3BB485510272_deref.body preserve=yes
    return *m_p;
      //## end XSutility::auto_array_ptr::operator*%3BB485510272_deref.body
    }



    //## Other Operations (implementation)
    template <typename X>
    X* auto_array_ptr<X>::get () const throw ()
    {
      //## begin XSutility::auto_array_ptr::get%3BB485910270.body preserve=yes
    return m_p;
      //## end XSutility::auto_array_ptr::get%3BB485910270.body
    }

    template <typename X>
    X* auto_array_ptr<X>::reset (X* p) throw ()
    {
      //## begin XSutility::auto_array_ptr::reset%3BB485AB0043.body preserve=yes
      // set the auto_ptr to manage p and return the old pointer it was managing.
      X* __tmp(m_p); 
      m_p = p;
      return __tmp;
      //## end XSutility::auto_array_ptr::reset%3BB485AB0043.body
    }

    template <typename X>
    void auto_array_ptr<X>::remove (X*& x) throw ()
    {
      //## begin XSutility::auto_array_ptr::remove%3BB485B50394.body preserve=yes
      X* __tmp(x);
      x = 0;
      delete [] __tmp;
      //## end XSutility::auto_array_ptr::remove%3BB485B50394.body
    }

    template <typename X>
    X* auto_array_ptr<X>::release () throw ()
    {
      //## begin XSutility::auto_array_ptr::release%3BB485DB039A.body preserve=yes
      return reset(0);
      //## end XSutility::auto_array_ptr::release%3BB485DB039A.body
    }

    template <typename X>
    void auto_array_ptr<X>::operator = (auto_array_ptr<X>& right) throw ()
    {
      //## begin XSutility::auto_array_ptr::operator=%3BB486A3008E.body preserve=yes
    if (this != &right)
    {
              remove(m_p);
              m_p = right.release();       
    }   
      //## end XSutility::auto_array_ptr::operator=%3BB486A3008E.body
    }

    template <typename X>
    X& auto_array_ptr<X>::operator [] (size_t index) throw ()
    {
      //## begin XSutility::auto_array_ptr::operator[]%3BB486CA0342.body preserve=yes
      return m_p[index];
      //## end XSutility::auto_array_ptr::operator[]%3BB486CA0342.body
    }

    template <typename X>
    X auto_array_ptr<X>::operator [] (size_t index) const throw ()
    {
      //## begin XSutility::auto_array_ptr::operator[]%3BB486EF037B.body preserve=yes
      return m_p[index];
      //## end XSutility::auto_array_ptr::operator[]%3BB486EF037B.body
    }

    // Parameterized Class XSutility::MatchSubKey 


    //## Other Operations (implementation)
    template <typename T>
    bool MatchSubKey<T>::operator () (const T& t, const string& k) const
    {
      //## begin XSutility::MatchSubKey::operator()%3C2259B801EF.body preserve=yes
          // match when then string k is a substring or equal to the key.
          // T& t is a pair and T& t.first is a string. will get compile errors
          // otherwise.
          bool match = false;
          if (t.first != k)
          {
              if (t.first.length() < k.length()) match = false;
              if (t.first.substr(0,k.length()) == k) return true;    
          }
          else 
          {
                  match = true;
          }
          
          return match;
      //## end XSutility::MatchSubKey::operator()%3C2259B801EF.body
    }

} // namespace XSutility

//## begin module%381DADC38060.epilog preserve=yes
namespace XSutility
{
         string addSuffix(const string&  oldName, XSutility::fileType  type = NONE);
} 
//## end module%381DADC38060.epilog


#endif
